"set the error format for perl
set errorformat=
	\%-G%.%#had\ compilation\ errors.,
	\%-G%.%#syntax\ OK,
	\%m\ at\ %f\ line\ %l.,
	\%+A%.%#\ at\ %f\ line\ %l\\,%.%#,
	\%+C%.%#

" Explanation:
" %-G%.%#had\ compilation\ errors.,  - Ignore the obvious.
" %-G%.%#syntax\ OK,                 - Don't include the 'a-okay' message.
" %m\ at\ %f\ line\ %l.,             - Most errors...
" %+A%.%#\ at\ %f\ line\ %l\\,%.%#,  - As above, including ', near ...'
" %+C%.%#                            -   ... Which can be multi-line.


imap }! <ESC>Yo{<C-M>mark!<ESC>o}#<ESC>pkJ$amark!<ESC>^%jump!
vmap f :call Refactor()
"col( {expr})			Number	column nr of cursor or mark
"cursor( {lnum}, {col})		Number  position cursor at {lnum}, {col}
"append({lnum}, {string})				*append()*

fun! Refactor() range
  let name = input("Name of new function:  ")
  execute a:firstline "," a:lastline "!makeperlfunc.pl" name
  execute 'normal! mzjV/{/'."\<CR>"
  execute "normal! %jd"
  execute "normal! /### EOC\<CR>P"
  execute 'normal! my/{/'."\<CR>"
  execute "normal! =%'y"
  execute "normal \<DEL>"
endfun

map <F2> :call Create()
fun! Create()
  let name = input("Name of new module:  ")
  if name !~ '\.p[lm]+$'
    let name = name.'.pm' 
  endif
  execute "!cp ~/.vimMacros/templates/perl.pm" name
  let name =~ s/'\.pm'//

  execute "edit " name
  execute "%substitute/progname/".name."/g"
  execute "%substitute/\.pm//g"
  execute "%substitute/\.pl//g"

endfun

